; MARco/theme.jl

;; Copyright (C) 2002 Marco Munari <mar@i.am> ,artistic tiny graphic icon logic
;; Copyright (C) 1999 Sander Klein Lebbink <sander@cerberus.demon.nl>

;; theme extended from theme StyleS sawfish

;; theme ported from the enlightenment-theme 'stylE'
;; by Andrew Cattau <cattand@charlie.cns.iit.edu>

(defgroup MARco-frame "MARco")

(defcustom MARco:title-font
  (get-font "-b&h-*-medium-r-*-*-10-*-*-*-*-*-*-*") ;maybe you need to change
  "Title font" ;;assigned to font-style
  :group MARco-frame
  :type font
  :after-set after-setting-frame-option)

(defcustom MARco:text-color "gray"
  "Title foreground color - not active"
  :group MARco-frame
  :type color
  :after-set after-setting-frame-option)

(defcustom MARco:text-color-a "white"
  "Title foreground color - active"
  :group MARco-frame
  :type color
  :after-set after-setting-frame-option)

(defcustom MARco:normal-title-just 'left
  "Title justification in normal border state"
  :group MARco-frame
  :type symbol
  :options (left center right)
  :after-set after-setting-frame-option)

(defcustom MARco:transient-title-just 'left
  "Title justification in transient border state"
  :group MARco-frame
  :type symbol
  :options (left center right)
  :after-set after-setting-frame-option)

(defcustom MARco:normal-title-fromside 2
  "Title distance from side in normal border state"
  :group MARco-frame
  :type number
  :range (0 . 250)
  :after-set after-setting-frame-option)

(defcustom MARco:transient-title-fromside 2
  "Title destance from side in transient border state"
  :group MARco-frame
  :type number
  :range (0 . 250)
  :after-set after-setting-frame-option)

(defcustom MARco:title-size 11 ;unused
  "Height of title bar (11 the best)"
  :group MARco-frame
  :type number
  :range (0 . 250)
  :after-set after-setting-frame-option)

(defcustom MARco:border-width 3 ;unused
  "vertical (left|right) Border width (3 is fine)"
  :group MARco-frame
  :type number
  :range (0 . 250)
  :after-set after-setting-frame-option)

(defcustom MARco:normal-shade-with-borders 't
  "Display border around titlebar when shading normal windows"
  :group MARco-frame
  :type boolean
  :after-set after-setting-frame-option)

(defcustom MARco:transient-shade-with-borders 't
  "Display border around titlebar when shading transient windows"
  :group MARco-frame
  :type boolean
  :after-set after-setting-frame-option)


;(define-structure sawfish.wm.commands.marco
;  (export local-www-page)
;  (define local-www-page
;    "Display local WWW page (eg http://mar.i.am for MAR)."
;    (require 'sawfish.wm.commands.help)
;    (display-url "http://mar.i.am/"))
;  (define-command local-www-page 'local-www-page))
;(setq root-menu
;      (list root-menu ("About MARco..." local-www-page)))
 ;i admit: it's for commercial purpose

;(defun about-mar()
;  "Display local WWW page (eg http://mar.i.am for MAR)."
;  (require 'sawfish.wm.commands.help)
;  (display-url "http://mar.i.am"))
(setq root-menu (append root-menu '(("About MARco..." (progn (require 'sawfish.wm.commands.help) (display-url "http://mar.i.am/pub/sawfish"))))))


(defvar sticky-button-keymap (make-keymap)
  "MARco defined sticky keymap for button")

(bind-keys sticky-button-keymap;(make-keymap);
	     "Button1-Off" 'toggle-window-sticky)

(def-frame-class sticky-button '((cursor . left_ptr))
  'sticky-button-keymap)


(let* ((normal-just
	(if (eq MARco:normal-title-just 'left)
	    MARco:normal-title-fromside
	  MARco:normal-title-just))

       (transient-just
	(if (eq MARco:transient-title-just 'left)
	    MARco:transient-title-fromside
	  MARco:transient-title-just))

       (normal-right-width
	(lambda ()
	  MARco:normal-title-fromside))

       (normal-fromside
	(lambda ()
	  (+ 33 MARco:normal-title-fromside)))

       (transient-right-width
	(lambda ()
	  MARco:transient-title-fromside))

       (transient-fromside
	(lambda ()
	  (+ 14 MARco:transient-title-fromside)))

       (bottom-images
	(list
	 (make-image "border/b.png")
	 (make-image "border/b3_a.png")))

       (top-left-images
	(make-image "corner/tl_0.png")
	(make-image "corner/tl_1.png")
	(make-image "corner/tl_2.png"))

       (top-images 			;title bar background (used in repeated way)
	(list
	 (make-image "border/bar3.png")	;unselected (gray)
	 (make-image "border/bar3_a.png"))) ;active (colored)

       (bar-left
	(list
	 (make-image "border/bar_left3.png") ;(make-sized-image... w h color)
	 (make-image "border/bar_left3_a.png")))

       (bar-right
	(list
	 (make-image "border/bar_right3.png")
	 (make-image "border/bar_right3_a.png")))

       (top-right-images
	(make-image "corner/tr_0.png")
	(make-image "corner/tr_1.png")
	(make-image "corner/tr_2.png"))

       (bottom-left-images
	(make-image "corner/bl_0.png")
	(make-image "corner/bl_1.png")
	(make-image "corner/bl_2.png"))

       (bottom-right-images
	(make-image "corner/br_0.png")
	(make-image "corner/br_1.png")
	(make-image "corner/br_2.png"))

       (close-images
	(list
	 (make-image "titleicon/kill/btne4_kill_0.png")
	 (make-image "titleicon/kill/btne4_kill_1.png")
	 (make-image "titleicon/kill/btne4_kill_2.png")
	 (make-image "titleicon/kill/btne4_kill_3.png")))

       (maximize-images
	(list
	 (make-image "titleicon/maxsize/btn3_max_0.png")
	 (make-image "titleicon/maxsize/btn3_max_1.png")
	 (make-image "titleicon/maxsize/btn3_max_2.png")
	 (make-image "titleicon/maxsize/btn3_max_3.png")))

       (iconify-images
	(list
	 (make-image "titleicon/iconify/btn3_iconify_0.png")
	 (make-image "titleicon/iconify/btn3_iconify_1.png")
	 (make-image "titleicon/iconify/btn3_iconify_2.png")
	 (make-image "titleicon/iconify/btn3_iconify_3.png")))

       (sticky-images
	(list
	 (make-image "titleicon/sticky/puntinap_0.png")
	 (make-image "titleicon/sticky/puntinap_1.png")
	 (make-image "titleicon/sticky/puntinap_2.png")
	 (make-image "titleicon/sticky/puntinap_3.png")))
       (unsticky-images
	(list
	 (make-image "titleicon/sticky/puntina_0.png")
	 (make-image "titleicon/sticky/puntina_1.png")
	 (make-image "titleicon/sticky/puntina_2.png")
	 (make-image "titleicon/sticky/puntina_3.png")))

       (menu-images
	(list
	 (make-image "titleicon/menu/btn_menu_0.png")
	 (make-image "titleicon/menu/btn_menu_1.png")
	 (make-image "titleicon/menu/btn_menu_2.png")
	 (make-image "titleicon/menu/btn_menu_3.png")))

       (left-images
	(list
	 (make-image "border/l.png")
	 (make-image "border/l3_a.png")))

       (right-images
	;(flip-images-horizontally costruirla con flip-image-horizontally affinche` operi su lista
	 left-images
	 ;)
        ;(list (make-image "border/r.png") (make-image "border/r_a.png"))
	)

       (top-line
	(flip-image-diagonally
	 (copy-image (car left-images))
	 ))

       (trans-images
	(make-image "trans.png"))

       (font-style
	(condition-case nil
	    MARco:title-font
	  (error
	   (condition-case nil
	       (get-font "-b&h-lucida-medium-r-normal-*-*-100-*-*-p-*-*-*")
	     (error
	      (condition-case nil
		  (get-font "-adobe-helvetica-medium-r-normal-*-*-100-*-*-p-*-*-*")
		(error default-font)))))))

       ;; frame layout

       (frame
	`(
	  ;; top-left corner ;angolo
	  ((background . ,top-left-images)
	   (left-edge . -3)
	   (top-edge . -11)
	   (class . top-left-corner))

	  ;; menu bar
	  ((background . ,menu-images)
	   (top-edge . -8)
	   (left-edge . 0)
	   (class . menu-button))

	  ;; +sticky button
	  ((background . ,unsticky-images)
	   (left-edge . 24)
	   (top-edge . -11)
	   (class . sticky-button))

	  ;; top bar left-side ;will be the corner smooth/mobile/prensile
	  ((background . ,bar-left)
	   (top-edge . -11)
	   (left-edge . 35)
	   (class . title))

	  ;; top bar
	  ((background . ,top-images)
	   (foreground . (,MARco:text-color ,MARco:text-color-a))
	   (text . ,window-name)
	   (font . ,font-style)
	   (x-justify . ,normal-just)
	   (y-justify . center)
	   (top-edge . -11)
	   (left-edge . 39)
	   (right-edge . ,normal-fromside)
	   (class . title))

	  ;; extra piece of bar
	  ((background . ,top-images)
	   (top-edge . -11)
	   (right-edge . 33)
	   (width . ,normal-right-width)
	   (class . title))
	  
	  ;; close button
	  ((background . ,close-images)
	   (right-edge . 0)
	   (top-edge . -11)
	   (class . close-button))

	  ;; maximize button
	  ((background . ,maximize-images)
	   (right-edge . 13)
	   (top-edge . -11)
	   (width . 11)
	   (class . maximize-button))

	  ;; iconify button
	  ((background . ,iconify-images)
	   (right-edge . 24)
	   (top-edge . -11)
	   (class . iconify-button))

	  ;; top bar right-side
	  ;((background . ,bar-right)
	  ; (right-edge . 35)
	  ; (top-edge . -11)
	  ; (class . title))

	  ;; extra top bar left ;barretta per ingrandire dal sopra angolare
	  ((background . ,top-line)
	   (left-edge . 3)
	   (top-edge . -11)
	   (width . 20)
	   (class . top-border))

	  ;; extra top bar right
	  ((background . ,top-line)
	   (right-edge . 3)
	   (top-edge . -11)
	   (width . ,(+ 11 11 13 -3)) ;11+11+13-3, vvv:vorrei poi sommare ,normal-right-width
	   (class . top-border))

	  ;; top-right corner
	  ((background . ,top-right-images)
	   (right-edge . -3)
	   (top-edge . -11)
	   (class . top-right-corner))

	  ;; left border
	  ((background . ,left-images)
	   (left-edge . -3)
	   (top-edge . -3)
	   (bottom-edge . 3)
	   (class . left-border))

	  ;; right border
	  ((background . ,right-images)
	   (right-edge . -3)
	   (top-edge . -3)
	   (bottom-edge . 3)
	   (class . right-border))
	  
	  ;; bottom border
	  ((background . ,bottom-images)
	   (left-edge . 3)
	   (right-edge . 3)
	   (bottom-edge . -3)
	   (class . bottom-border))
	  
	  ;; bottom-left corner
	  ((background . ,bottom-left-images)
	   (left-edge . -3)
	   (bottom-edge . -3)
	   (class . bottom-left-corner))
	  
	  ;; bottom-right corner
	  ((background . ,bottom-right-images)
	   (right-edge . -3)
	   (bottom-edge . -3)
	   (class . bottom-right-corner))))

       (sticky-frame
	`(
	  ;; top-left corner
	  ((background . ,top-left-images)
	   (left-edge . -3)
	   (top-edge . -11)
	   (class . top-left-corner))

	  ;; menu bar
	  ((background . ,menu-images)
	   (top-edge . -8)
	   (left-edge . 0)
	   (class . menu-button))

	  ;; top bar left-side
	  ((background . ,bar-left)
	   (top-edge . -11)
	   (left-edge . 24)
	   (class . title))

	  ;; top bar
	  ((background . ,top-images)
	   (foreground . (,MARco:text-color ,MARco:text-color-a))
	   (text . ,window-name)
	   (font . ,font-style)
	   (x-justify . ,normal-just)
	   (y-justify . center)
	   (top-edge . -11)
	   (left-edge . 28)
	   (right-edge . ,normal-fromside)
	   (class . title))

	  ;; extra piece of bar
	  ((background . ,top-images)
	   (top-edge . -11)
	   (right-edge . 40)
	   (width . ,normal-right-width)
	   (class . title))
	  
	  ;; close button
	  ((background . ,close-images)
	   (right-edge . 0)
	   (top-edge . -11)
	   (class . close-button))

	  ;; +sticky button
	  ((background . ,sticky-images)
	   (right-edge . 24)
	   (top-edge . -11)
	   (class . sticky-button))

	  ;;; top bar right-side
	  ;((background . ,bar-right)
	  ; (right-edge . 35)
	  ; (top-edge . -11)
	  ; (class . title))

	  ;; maximize button
	  ((background . ,maximize-images)
	   (right-edge . 13)
	   (top-edge . -11)
	   (class . maximize-button))

	  ;; iconify button
	  ((background . ,iconify-images)
	   (right-edge . 24)
	   (top-edge . -11)
	   (class . iconify-button))

	  ;; extra bar left
	  ((background . ,top-line)
	   (left-edge . 3)
	   (top-edge . -11)
	   (width . 20)
	   (class . title))

	  ;; extra bar right
	  ((background . ,top-line)
	   (right-edge . 3)
	   (top-edge . -11)
	   (width . 20)
	   (class . title))

	  ;; top-right corner
	  ((background . ,top-right-images)
	   (right-edge . -3)
	   (top-edge . -11)
	   (class . top-right-corner))

	  ;; left border
	  ((background . ,left-images)
	   (left-edge . -3)
	   (top-edge . -3)
	   (bottom-edge . 3)
	   (class . left-border))

	  ;; right border
	  ((background . ,right-images)
	   (right-edge . -3)
	   (top-edge . -3)
	   (bottom-edge . 3)
	   (class . right-border))
	  
	  ;; bottom border
	  ((background . ,bottom-images)
	   (left-edge . 3)
	   (right-edge . 3)
	   (bottom-edge . -3)
	   (class . bottom-border))
	  
	  ;; bottom-left corner
	  ((background . ,bottom-left-images)
	   (left-edge . -3)
	   (bottom-edge . -3)
	   (class . bottom-left-corner))
	  
	  ;; bottom-right corner
	  ((background . ,bottom-right-images)
	   (right-edge . -3)
	   (bottom-edge . -3)
	   (class . bottom-right-corner))))

       (shaped-frame
	;;list of frame parts:
	`(
	  ;; left-transparency
	  ((background . ,trans-images)
	   (top-edge . -3)
	   (left-edge . -3)
	   (class . left-border))

	  ;; menu bar
	  ((background . ,menu-images)
	   (top-edge . -8)
	   (left-edge . 0)
	   (class . menu-button))

	  ;; top bar left-side
	  ((background . ,bar-left)
	   (top-edge . -11)
	   (left-edge . 24)
	   (class . title))

	  ;; top bar
	  ((background . ,top-images)
	   (foreground . (,MARco:text-color ,MARco:text-color-a))
	   (text . ,window-name)
	   (font . ,font-style)
	   (x-justify . ,normal-just)
	   (y-justify . center)
	   (top-edge . -11)
	   (left-edge . 28)
	   (right-edge . ,normal-fromside)
	   (class . title))

	  ;; extra piece bar
	  ((background . ,top-images)
	   (top-edge . -11)
	   (right-edge . 40)
	   (width . ,normal-right-width)
	   (class . title))

	  ;; close button
	  ((background . ,close-images)
	   (right-edge . 0)
	   (top-edge . -11)
	   (class . close-button))

	  ;; top bar right-side
	  ((background . ,bar-right)
	   (right-edge . 35)
	   (top-edge . -11)
	   (class . title))

	  ;; maximize button
	  ((background . ,maximize-images)
	   (right-edge . 13)
	   (top-edge . -11)
	   (class . maximize-button))

	  ;; iconify button
	  ((background . ,iconify-images)
	   (right-edge . 24)
	   (top-edge . -11)
	   (class . iconify-button))

	  ;; right transparency
	  ((background . ,trans-images)
	   (right-edge . -3)
	   (top-edge . -3)
	   (class . right-border))

	  ;; bottom border
	  ((background . ,bottom-images)
	   (left-edge . 3)
	   (right-edge . 3)
	   (bottom-edge . -3)
	   (class . bottom-border))))

       (normal-shade-frame
	`(
	  ;; menu bar
	  ((background . ,menu-images)
	   (top-edge . -8)
	   (left-edge . 0)
	   (class . menu-button))

	  ;; top bar left-side
	  ((background . ,bar-left)
	   (top-edge . -11)
	   (left-edge . 24)
	   (class . title))

	  ;; top bar
	  ((background . ,top-images)
	   (foreground . (,MARco:text-color ,MARco:text-color-a))
	   (text . ,window-name)
	   (font . ,font-style)
	   (x-justify . ,normal-just)
	   (y-justify . center)
	   (top-edge . -11)
	   (left-edge . 28)
	   (right-edge . ,normal-fromside)
	   (class . title))

	  ;; extra piece of bar
	  ((background . ,top-images)
	   (top-edge . -11)
	   (right-edge . 40)
	   (width . ,normal-right-width)
	   (class . title))

	  ;; close button
	  ((background . ,close-images)
	   (right-edge . 0)
	   (top-edge . -11)
	   (class . close-button))

	  ;; top bar right-side
	  ((background . ,bar-right)
	   (right-edge . 35)
	   (top-edge . -11)
	   (class . title))

	  ;; maximize button
	  ((background . ,maximize-images)
	   (right-edge . 13)
	   (top-edge . -11)
	   (class . maximize-button))

	  ;; iconify button
	  ((background . ,iconify-images)
	   (right-edge . 24)
	   (top-edge . -11)
	   (class . iconify-button))

	  ;; top-left corner
	  ((background . ,top-left-images)
	   (left-edge . -3)
	   (top-edge . -11)
	   (class . title))

	  ;; top border left
	  ((background . ,top-line)
	   (left-edge . 3)
	   (top-edge . -11)
	   (width . 20)
	   (class . title))

	  ;; top border right
	  ((background . ,top-line)
	   (right-edge . 3)
	   (top-edge . -11)
	   (width . 20)
	   (class . title))

	  ;; top-right corner
	  ((background . ,top-right-images)
	   (right-edge . -3)
	   (top-edge . -11)
	   (class . title))

	  ;; right border
	  ((background . ,right-images)
	   (right-edge . -3)
	   (top-edge . -8)
	   (height . 2)
	   (class . title))

	  ;; bottom-right corner
	  ((background . ,bottom-right-images)
	   (right-edge . -3)
	   (top-edge . -3) 
	   (class . title))

	  ;; bottom border
	  ((background . ,bottom-images)
	   (right-edge . 3)
	   (top-edge . 0)
	   (left-edge . 3)
	   (class . title))

	  ;; bottom-left corner
	  ((background . ,bottom-left-images)
	   (left-edge . -3)
	   (top-edge . -3)
	   (class . title))

	  ;; left border
	  ((background . ,left-images)
	   (left-edge . -3)
	   (top-edge . -8)
	   (height . 2)
	   (class . title))))

       (small-border-frame
	`(
	  ;; top bar left
	  ((background . ,bar-left)
	   (left-edge . 0)
	   (top-edge . -11)
	   (class . title))

	  ;; title-bar
	  ((background . ,top-images)
	   (foreground . (,MARco:text-color ,MARco:text-color-a))
	   (text . ,window-name)
	   (font . ,font-style)
	   (x-justify . ,transient-just)
	   (y-justify . center)
	   (left-edge . 3)
	   (top-edge . -11)
	   (right-edge . ,transient-fromside)
	   (class . title))

	  ;; extra piece of bar
	  ((background . ,top-images)
	   (top-edge . -11)
	   (right-edge . 14)
	   (width . ,transient-right-width)
	   (class . title))

	  ;; close button
	  ((background . ,close-images)
	   (right-edge . 0)
	   (top-edge . -11)
	   (class . close-button))

	  ;; top bar right
	  ((background . ,bar-right)
	   (right-edge . 0)
	   (top-edge . -11)
	   (class . title))

	  ;; top-left corner
	  ((background . ,top-left-images)
	   (left-edge . -3)
	   (top-edge . -11)
	   (class . top-left-corner))

	  ;; top-right corner
	  ((background . ,top-right-images)
	   (right-edge . -3)
	   (top-edge . -11)
	   (class . top-right-corner))

	  ;; top border
	  ((background . ,top-line)
	   (left-edge . 3)
	   (right-edge . 3)
	   (top-edge . -11)
	   (class . top-border))

	  ;; bottom border
	  ((background . ,bottom-images)
	   (left-edge . 3)
	   (right-edge . 3)
	   (bottom-edge . -3)
	   (class . bottom-border))

	  ;; bottom-left corner
	  ((background . ,bottom-left-images)
	   (left-edge . -3)
	   (bottom-edge . -3)
	   (class . bottom-left-corner))

	  ;; bottom-right corner
	  ((background . ,bottom-right-images)
	   (right-edge . -3)
	   (bottom-edge . -3)
	   (class . bottom-right-corner))

	  ;; right border
	  ((background . ,right-images)
	   (right-edge . -3)
	   (top-edge . -8)
	   (bottom-edge . 3)
	   (class . right-border))

	  ;; left border
	  ((background . ,left-images)
	   (left-edge . -3)
	   (top-edge . -8)
	   (bottom-edge . 3)
	   (class . left-border))))

       (title-only-frame
	`(
	  ;; transparency left
	  ((background . ,trans-images)
	   (left-edge . -3)
	   (top-edge . -11)
	   (class . title))

	  ;; left-side bar
	  ((background . ,bar-left)
	   (left-edge . 0)
	   (top-edge . -11)
	   (class . title))

	  ;; title bar
	  ((background . ,top-images)
	   (foreground . (,MARco:text-color ,MARco:text-color-a))
	   (text . ,window-name)
	   (font . ,font-style)
	   (x-justify . ,transient-just)
	   (y-justify . center)
	   (left-edge . 3)
	   (right-edge . ,transient-fromside)
	   (top-edge . -11)
	   (class . title))

	  ;; extra piece of bar
	  ((background . ,top-images)
	   (top-edge . -11)
	   (right-edge . 16)
	   (width . ,transient-right-width)
	   (class . title))

	  ;; close button
	  ((background . ,close-images)
	   (right-edge . 0)
	   (top-edge . -11)
	   (class . close-button))

	  ;;; right-side bar
	  ;((background . ,bar-right)
	  ; (right-edge . 0)
	  ; (top-edge . -11)
	  ; (class . title))

	  ;; right transparency
	  ((background . ,trans-images)
	   (right-edge . -3)
	   (top-edge . -11)
	   (class . title))))

       (title-only-bar-frame
	`(
	  ;; left-side bar
	  ((background . ,bar-left)
	   (left-edge . 0)
	   (top-edge . -11)
	   (class . title))

	  ;; title bar
	  ((background . ,top-images)
	   (foreground . (,MARco:text-color ,MARco:text-color-a))
	   (text . ,window-name)
	   (font . ,font-style)
	   (x-justify . ,transient-just)
	   (y-justify . center)
	   (left-edge . 3)
	   (right-edge . ,transient-fromside)
	   (top-edge . -11)
	   (class . title))

	  ;; extra piece of bar
	  ((background . ,top-images)
	   (top-edge . -11)
	   (right-edge . 16)
	   (width . ,transient-right-width)
	   (class . title))

	  ;; close button
	  ((background . ,close-images)
	   (right-edge . 0)
	   (top-edge . -11)
	   (class . close-button))

	  ;; right-side bar
	  ((background . ,bar-right)
	   (right-edge . 0)
	   (top-edge . -11)
	   (class . title))

	  ;; top-left corner
	  ((background . ,top-left-images)
	   (left-edge . -3)
	   (top-edge . -11)
	   (class . title))

	  ;; top border
	  ((background . ,top-line)
	   (left-edge . 3)
	   (top-edge . -11)
	   (right-edge . 3)
	   (class . title))

	  ;; top-right corner
	  ((background . ,top-right-images)
	   (right-edge . -3)
	   (top-edge . -11)
	   (class . title))

	  ;; right border
	  ((background . ,right-images)
	   (right-edge . -3)
	   (top-edge . -6)
	   (height . 3)
	   (class . title))

	  ;; bottom-right corner
	  ((background . ,bottom-right-images)
	   (right-edge . -3)
	   (top-edge . -3)
	   (class . title))

	  ;; bottom border
	  ((background . ,bottom-images)
	   (right-edge . 3)
	   (left-edge . 3)
	   (top-edge . 0)
	   (class . title))

	  ;; bottom-left corner
	  ((background . ,bottom-left-images)
	   (left-edge . -3)
	   (top-edge . -3)
	   (class . title))

	  ;; left border
	  ((background . ,left-images)
	   (left-edge . -3)
	   (top-edge . -6)
	   (height . 3)
	   (class . title)))))

  (add-frame-style 'MARco
    (lambda (w type)
      ;;(setq sticky-images (if (window-get w 'sticky)  ;v.anche: rplaca
      ;;		      'sticked-images 'unsticked-images))
      (cond
       ((eq type 'shaped)
	(if (window-get w 'shaded)
	    (if (eq MARco:normal-shade-with-borders 't)
		(if (eq (window-get w 'shaded-old-type) 'shaped)
		    shaped-frame
		  normal-shade-frame)
	      shaped-frame)
	  shaped-frame))
       ((eq type 'transient) small-border-frame)
       ((eq type 'shaped-transient)
	(if (window-get w 'shaded)
	    (if (eq MARco:transient-shade-with-borders 't)
		(if (eq (window-get w 'shaded-old-type) 'shaped-transient)
		    title-only-frame
		  title-only-bar-frame)
	      title-only-frame)
	  title-only-frame))
       ((eq type 'unframed) nil-frame)
       (t (if (window-get w 'sticky)
	      sticky-frame
	    frame))))))

;user> frame-part-classes
;((bottom-right-corner (cursor . #<closure 80b2bf0>) (keymap . border-keymap))
; (bottom-left-corner (cursor . #<closure 80b30c8>) (keymap . border-keymap))
; (top-right-corner (cursor . #<closure 80b30f0>) (keymap . border-keymap))
; (top-left-corner (cursor . #<closure 80b3118>) (keymap . border-keymap))
; (right-border (cursor . #<closure 80b3140>) (keymap . border-keymap))
; (left-border (cursor . #<closure 80b3168>) (keymap . border-keymap))
; (bottom-border (cursor . #<closure 80b3190>) (keymap . border-keymap))
; (top-border (cursor . #<closure 80b31b8>) (keymap . border-keymap))
; (title (keymap . title-keymap) (cursor . #<closure 80b31e0>))
; (shade-button (keymap . shade-button-keymap))
; (maximize-button (keymap . maximize-button-keymap))
; (iconify-button (keymap . iconify-button-keymap))
; (close-button (keymap . close-button-keymap))
; (menu-button (keymap . menu-button-keymap)))
